<template>
<div>
  <div class="d-flex ml-auto mr-2 p-0 "><span class="btn" @click="goBack()"> ..<font-awesome-icon class="card-img-top" color="firebrick" icon="reply" /></span></div>

  <div class="  border overflow " style="font-size: 12px;">

    <div  id="folders" class="card border-0 d-flex flex-grow-0 flex-shrink-0 flex-row justify-content-start align-items-center"  v-for="(folder,key) in folders" :key="key+folder" @click="selectFolder(folder)" :class="{'selected' : isSelected(folder)}"  @dblclick="openFolder(folder)">
      <span class="btn m-0 p-0"> <font-awesome-icon class="card-img-top"  color="#CFB53B" icon="folder" size="lg"/>
      </span>
        <span class="text-muted p-0 m-0 ml-2"><span class=" overflow">{{folder}}</span></span>
    </div>
    <div id="files" class="card  d-flex flex-row flex-grow-0 flex-shrink-0 justify-content-start align-items-center" v-for="(file,key) in files" :key="key+file">
       <font-awesome-icon  :title="file" class="card-img-top" color="grey" icon="file" size="lg"/>
        <div  class=" text-muted p-0 m-0 ml-2"> <div class=" overflow">{{file}}</div> </div>
    </div>
  </div>
  </div>
</template>
<script>
import path from 'path'
export default {
  name : 'FileExplorer',
  props:[
    'server',
  ],
    watch:{
    server :{
      handler: function (val, oldVal) {
        this.files=[]
        this.folders=[]
        this.selected=''
        this.getfiles()
       },
      immediate: true
    }
  },
  data (){
    return {
      user: JSON.parse(localStorage.getItem("user")),
      files :[],
      folders :[],
      selected :'',
      basePath :'',
    }
  },
  methods :{
    getfiles : function (){
    var data={
      serverId : this.server.id,
      userId : this.user.id,
      folder : this.basePath,
      token  : localStorage.getItem("jwt")
    }
    //console.log(data.folder)
    this.$socket.emit('reqFiles',data)
    },

    selectFolder : function(folder){
       this.selected=path.join(this.basePath,folder)
       //console.log(this.selected)
       this.$emit('libraryFolder',this.selected)
    },

    openFolder : function(folder){
      //console.log(path.join(this.basePath,folder))
      this.basePath=path.join(this.basePath,folder)
      this.getfiles()
    },
    isSelected(folder){
      //console.log(path.basename(this.selected) + " = " + folder)
      if (path.basename(this.selected)==folder) return true;

    },
    goBack(){
      this.selected=''
      this.basePath=path.normalize(path.join(this.basePath,'..')) //go one level directory back
      this.getfiles()
    }
  },

  mounted (){
    this.$socket.on('resFiles',(data)=>{
      this.files=data.files,
      this.folders=data.dirs
    })
  }
}
</script>

<style scoped>
  .selected{
    border: 1px;
    background-color:lightskyblue;
  }
  .overflow{
    max-height:12em;
    overflow-y:auto;
    overflow-x:hidden;
    white-space:nowrap;
    text-overflow: ellipsis;

  }
</style>
